package org.especialistajee.jhd.filmoteca;

import java.util.Collections;
import java.util.List;
import java.util.Scanner;

import org.especialistajee.jhd.filmoteca.dao.DAOException;
import org.especialistajee.jhd.filmoteca.dao.GestorDAO;
import org.especialistajee.jhd.filmoteca.dao.IPeliculaDAO;
import org.especialistajee.jhd.filmoteca.to.PeliculaTO;


public class Main {

	public static void main(String[] args) {
		mostrarMenu();
	}

	public static void mostrarMenu() {
		while(true) {
			System.out.println(Messages.getString("Main.addMovie")); //$NON-NLS-1$
			System.out.println(Messages.getString("Main.delMovie")); //$NON-NLS-1$
			System.out.println(Messages.getString("Main.listMovies")); //$NON-NLS-1$
			System.out.println(Messages.getString("Main.exit")); //$NON-NLS-1$
		
			System.out.print(Messages.getString("Main.option")); //$NON-NLS-1$
			Scanner s = new Scanner(System.in);
			int opcion = s.nextInt();
			
			try {
				switch(opcion) {
				case 1:
					agregarPelicula();
					break;
				case 2:
					borrarPelicula();
					break;
				case 3:
					mostrarPeliculas();
					break;
				case 0:
					System.exit(0);
					break;
				default:
					System.out.println(Messages.getString("Main.invalidOption"));	 //$NON-NLS-1$
				}									
			} catch(DAOException e) {
				System.err.println("Error: " + e.getMessage());
				e.printStackTrace();
			}
		}
	}
	
	public static void agregarPelicula() throws DAOException {
		IPeliculaDAO fpdao = GestorDAO.getPeliculaDAO();
		Scanner s;
		
		System.out.println(Messages.getString("Main.id")); //$NON-NLS-1$
		s = new Scanner(System.in);
		int id = s.nextInt();
		System.out.println(Messages.getString("Main.title")); //$NON-NLS-1$
		s = new Scanner(System.in);
		String titulo = s.nextLine();
		
		PeliculaTO p = new PeliculaTO();
		p.setId(id);
		p.setTitulo(titulo);
		
		fpdao.addPelicula(p);
	}

	public static void borrarPelicula() throws DAOException {
		IPeliculaDAO fpdao = GestorDAO.getPeliculaDAO();

		List<PeliculaTO> peliculas = fpdao.getAllPeliculas();

		if(peliculas==null || peliculas.size()==0) {
			System.out.println(Messages.getString("Main.noMovies")); //$NON-NLS-1$
			return;
		}
		
		for(int i=0;i<peliculas.size();i++) {
			PeliculaTO p = peliculas.get(i);
			System.out.println("[" + i + "] " + p.getTitulo()); //$NON-NLS-1$ //$NON-NLS-2$
		}
		
		System.out.println(Messages.getString("Main.movieToDelete")); //$NON-NLS-1$
		Scanner s = new Scanner(System.in);
		int indice = s.nextInt();
		
		PeliculaTO p = peliculas.get(indice);
		
		fpdao.delPelicula(p.getId());
	}

	public static void mostrarPeliculas() throws DAOException {
		IPeliculaDAO fpdao = GestorDAO.getPeliculaDAO();

		List<PeliculaTO> peliculas = fpdao.getAllPeliculas();
		Collections.sort(peliculas);
		
		if(peliculas==null || peliculas.size()==0) {
			System.out.println(Messages.getString("Main.noMovies")); //$NON-NLS-1$
			return;
		}
		
		for(int i=0;i<peliculas.size();i++) {
			PeliculaTO p = peliculas.get(i);
			System.out.println("[" + i + "] " + p.getTitulo()); //$NON-NLS-1$ //$NON-NLS-2$
		}
	}
}
