package org.especialistajee.jhd.tienda.bo;

import org.especialistajee.jhd.tienda.dao.DAOException;
import org.especialistajee.jhd.tienda.dao.IEmpleadoDAO;
import org.especialistajee.jhd.tienda.dao.JDBCEmpleadoDAO;
import org.especialistajee.jhd.tienda.to.EmpleadoTO;

public class EmpleadoBO {

	public float getSalarioBruto(int idEmpleado) throws BOException {

		IEmpleadoDAO edao = getEmpleadoDAO();
		EmpleadoBR ebr = new EmpleadoBR();
		
		try {
			EmpleadoTO empleado = edao.getEmpleado(idEmpleado);
			if(empleado==null) {
				throw new BOException("El usuario no existe");
			}
			
			return ebr.calculaSalarioBruto(empleado.getTipo(), empleado.getVentasMes(), empleado.getHorasExtra());
		} catch (DAOException e) {
			throw new BOException("Error al obtener el salario bruto", e);
		} catch(BRException e) {
			throw new BOException("Error al calcular el salario bruto", e);			
		}
	}

	IEmpleadoDAO getEmpleadoDAO() {
		System.out.println("Original");
		IEmpleadoDAO edao = new JDBCEmpleadoDAO();
		return edao;
	}

}
