package org.especialistajee.jhd.tienda.dao;

import java.util.ArrayList;
import java.util.List;

import org.especialistajee.jhd.tienda.dao.DAOException;
import org.especialistajee.jhd.tienda.dao.IEmpleadoDAO;
import org.especialistajee.jhd.tienda.to.EmpleadoTO;


public class MockEmpleadoDAO implements IEmpleadoDAO {

	List<EmpleadoTO> listaEmpleados;
	boolean falloConexion;
	
	public MockEmpleadoDAO(boolean falloConexion) {
		listaEmpleados = new ArrayList<EmpleadoTO>();
		this.falloConexion = falloConexion;
	}
	
	private void compruebaConexion() throws DAOException {
		if(falloConexion) {
			throw new DAOException("Fallo al conectar a la BD");
		}		
	}
	
	public void addEmpleado(EmpleadoTO empleado) throws DAOException {
		this.compruebaConexion();
		if(this.getEmpleado(empleado.getId()) == null) {
			listaEmpleados.add(empleado);
		} else {
			throw new DAOException("El empleado la existe en la BD");
		}
	}

	public void delEmpleado(int idEmpleado) throws DAOException {
		this.compruebaConexion();
		EmpleadoTO empleado = this.getEmpleado(idEmpleado); 
		if(empleado != null) {
			listaEmpleados.remove(empleado);
		} else {
			throw new DAOException("El empleado no existe en la BD");
		}
	}

	public EmpleadoTO getEmpleado(int idEmpleado) throws DAOException {
		this.compruebaConexion();
		for(EmpleadoTO empleado: listaEmpleados) {
			if(empleado.getId() == idEmpleado) {
				return empleado;
			}
		}
		
		return null;
	}

	public List<EmpleadoTO> getEmpleados() throws DAOException {
		this.compruebaConexion();
		return listaEmpleados;
	}
}
